#editor.py
#Copyright (C) 2006 Evil Mr Henry
#This file is part of The Monster's Tower.

#The Monster's Tower is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.

#The Monster's Tower is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with The Monster's Tower; if not, write to the Free Software
#Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


#This is the map editor for the game.

import pygame
import sys

import level

pygame.init()
pygame.font.init()
screen_size = (640, 480)
global screen
screen = pygame.display.set_mode(screen_size)

pos = (0, 0)

cur_levelname = "001.txt"
mapindex = 0

def draw_tile(x,y):
    if x < 0: return
    if y < 0: return
    if y >= level.maps[mapindex].size[1]: return
    if x >= level.maps[mapindex].size[0]: return

    if level.maps[mapindex].grid[y][x] == '1':
        pygame.draw.rect(screen, (0, 120, 0, 0), ((x-pos[0]+20)*16, (y-pos[1]+15)*16, 15, 15))
    elif level.maps[mapindex].grid[y][x] == '0':
        pygame.draw.rect(screen, (120, 120, 120, 0), ((x-pos[0]+20)*16, (y-pos[1]+15)*16, 15, 15))

def draw_frame():
    screen.fill((0,0,0,0))
    for x in range(pos[0]-20, pos[0]+20):
        for y in range(pos[1]-15, pos[1]+15):
            draw_tile(x, y)
    pygame.draw.rect(screen, (200, 200, 200, 0),
            ((level.maps[mapindex].startpos[0]-pos[0]+20)*16+6,
            (level.maps[mapindex].startpos[0]-pos[1]+15)*16+6, 4, 4))
    for enemy in level.maps[mapindex].enemy_list:
        pygame.draw.rect(screen, (120, 0, 0, 0),
        ((enemy.baseloc[0]-pos[0]+20)*16+7,
        (enemy.baseloc[1]-pos[1]+15)*16+7, 2, 2))
    pygame.draw.rect(screen, (0, 0, 120, 0), (20*16, 15*16, 3, 3))
    pygame.draw.rect(screen, (0, 0, 120, 0), (20*16, 15*16+12, 3, 3))
    pygame.draw.rect(screen, (0, 0, 120, 0), (20*16+12, 15*16, 3, 3))
    pygame.draw.rect(screen, (0, 0, 120, 0), (20*16+12, 15*16+12, 3, 3))
    pygame.display.flip()

def move(x, y):
    global pos
    pos = (pos[0]+x, pos[1]+y)
    if pos[0] < 0: pos = (0, pos[1])
    if pos[1] < 0: pos = (pos[0], 0)

    if pos[0] >= level.maps[mapindex].size[0]:
        pos = (level.maps[mapindex].size[0]-1, pos[1])
    if pos[1] >= level.maps[mapindex].size[1]:
        pos = (pos[0], level.maps[mapindex].size[1]-1)


pygame.key.set_repeat(350, 75)
while 1:
    time = pygame.time.wait(40)
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            sys.exit()
        elif event.type == pygame.KEYDOWN:
            if event.key == pygame.K_ESCAPE:
                sys.exit()
            elif event.key == pygame.K_UP: move(0, -1)
            elif event.key == pygame.K_DOWN: move(0, 1)
            elif event.key == pygame.K_LEFT: move(-1, 0)
            elif event.key == pygame.K_RIGHT: move(1, 0)
            elif event.key == pygame.K_PAGEUP: move(0, -10)
            elif event.key == pygame.K_PAGEDOWN: move(0, 10)
            elif event.key == pygame.K_TAB: move(10, 0)
            elif event.key == pygame.K_BACKSPACE: move(-10, 0)
            elif event.key == pygame.K_SPACE:
                if level.maps[mapindex].grid[pos[1]][pos[0]] == '1':
                    level.maps[mapindex].grid[pos[1]][pos[0]] = '0'
                elif level.maps[mapindex].grid[pos[1]][pos[0]] == '0':
                    level.maps[mapindex].grid[pos[1]][pos[0]] = '1'
    draw_frame()


