#game.py
#Copyright (C) 2006 Evil Mr Henry
#This file is part of The Monster's Tower.

#The Monster's Tower is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.

#The Monster's Tower is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with The Monster's Tower; if not, write to the Free Software
#Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import pygame

import display
import level
import enemy
import g

global clock
clock = pygame.time.Clock()

global loc

def move(x, y):
    global loc
    loc, x, y = g.wallcheck(loc, x, y)

    #actually move
    loc = (loc[0]+x, loc[1]+y)

global z
def zoom(tmp_zoom):
    global z
    z += tmp_zoom
    if z < 8: z = 8
    if z > 30: z = 30


def main():
    global loc
    video_flags = pygame.OPENGL|pygame.DOUBLEBUF
    global z
    z = 15.0

    pygame.init()
    surface = pygame.display.set_mode((640,480), video_flags)

    display.setup_opengl((640,480))
    #pygame.event.set_grab(1)
    pygame.mouse.set_visible(0)

    display.load_level(0)
    loc = (level.maps[0].startpos[0]*10.0+5.0, level.maps[0].startpos[1]*10.0+5.0)
    quit_game = False
    i = 0
    while 1:
        if quit_game: break
        time = clock.tick(120)
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                quit_game = True
            if event.type == pygame.KEYDOWN:
                if event.key == pygame.K_ESCAPE:
                    quit_game = True
            if event.type == pygame.MOUSEBUTTONDOWN:
                if event.button == 4:
                    quit_game = zoom(-0.6)
                if event.button == 5:
                    quit_game = zoom(0.6)
        temp = pygame.key.get_pressed()
        x = y = 0
        if temp[pygame.K_UP]: y = -0.06*time
        if temp[pygame.K_DOWN]: y = 0.06*time
        if temp[pygame.K_LEFT]: x = -0.06*time
        if temp[pygame.K_RIGHT]: x = 0.06*time
        if temp[pygame.K_PAGEUP]: zoom(-0.3)
        if temp[pygame.K_PAGEDOWN]: zoom(0.3)
        move(x, y)
        for enemy in level.maps[0].enemy_list:
            enemy.move(time)
        display.draw_frame(loc, z)
        i += 1
        if i % 200 == 0:
            print clock.get_fps()
            i = 0
        pygame.display.flip()


main()
